<script lang="ts">
import Vue from 'vue';
import VideoModal from '~/components/solutions/video-modal.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  components: {
    VideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    videoUrl: {
      type: String,
      required: false,
      default: null,
    },
    mp4Url: {
      type: String,
      required: false,
      default: null,
    },
    webmUrl: {
      type: String,
      required: false,
      default: null,
    },
  },
  data: () => ({
    showModal: false,
  }),
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <div class="wrapper" @click="openModal()">
      <SlpIcon
        class="play-icon"
        name="play-circle"
        variant="marketing"
        size="96"
      />
      <video class="video-looping" autoplay loop muted playsinline>
        <source :src="mp4Url" type="video/mp4" />
        <source :src="webmUrl" type="video/webm" />
      </video>
    </div>
    <SlpContainer style="border: 0">
      <VideoModal
        v-show="showModal && videoUrl"
        :visible="showModal"
        @close="showModal = false"
      >
        <template #body>
          <lite-vimeo
            :videoid="getVimeoVideoId(createVideoSource(videoUrl))"
            autoplay
          ></lite-vimeo>
        </template>
      </VideoModal>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  position: relative;
  z-index: 1;

  .hero-container__buttons {
    :deep .slp-btn {
      @media (max-width: $breakpoint-sm) {
        width: 100%;
        justify-content: center;
      }
    }
  }
}

@keyframes intro-reveal {
  from {
    transform: translate3d(0, 150%, 0);
  }
  to {
    transform: translate3d(0, 0%, 0);
  }
}

@keyframes opacity-intro {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

.wrapper {
  position: relative;
  cursor: pointer;
  overflow: hidden;
  display: flex;
  align-items: center;
  justify-content: center;

  .play-icon {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    font-size: 48px;
    color: $color-surface-700;
    cursor: pointer;
    z-index: 2;
    border: 2px solid $color-surface-600;
    border-radius: 9999px;
    box-sizing: content-box;

    ::v-deep path {
      fill: $color-surface-50;
      transition: color 0.2s ease;
    }

    ::v-deep circle {
      transition: color 0.2s ease;
    }
  }

  lite-video {
    &:deep iframe {
      left: 0;
    }
  }
  .video-looping {
    width: 100%;
    filter: brightness(0.6);
    object-fit: cover;

    &:hover {
      .play-icon::v-deep {
        color: #1e1d43;
      }
    }
  }

  &:hover {
    .thumbnail-image {
      filter: brightness(0.9);
    }

    .play-icon::v-deep {
      circle {
        color: #1e1d43;
      }
      path {
        color: $color-surface-50;
      }
    }
  }

  .thumbnail-image {
    position: relative;
    display: block;
    cursor: pointer;
    width: 100%;
    height: 100%;
    max-height: 600px;
    object-fit: cover;
    object-position: center;
    transition: all 0.2s ease;
  }
}
</style>
